<?php
namespace PAE\Controllers\Import;

use Teknisa\Libs\Util\XLS\FileReader;
use PHPExcel_Cell;

class XlsImportFile extends ImportFile 
{
    private $spreadsheet;
    private $columnNames;
    
    protected function getContent(): void
    {
        if (!$this->columnNames)
            throw new \Exception("Atributo columnNames deve ser definido");
            
        $worksheet = $this->fileContent->getActiveSheet();
        $this->spreadsheet = FileReader::readWorksheetTable($worksheet, $this->columnNames);
    }

    protected function formatContent(): void
    {
        //$columnsReference = $this->spreadsheet->getColumnsReference();
        $this->content = $this->spreadsheet->getRows();
        //$columnsNumber = $this->spreadsheet->getNumberOfColumns();
        $i = 0;
        foreach ($this->content as &$row) {
            $row = $row['content'];
            // for($column = 0; $column < $columnsNumber; $column++) {
            //     $columnLetterIndex = PHPExcel_Cell::stringFromColumnIndex($column);
            //     $columnName = $columnsReference[$columnLetterIndex];
            //     $row[$columnName] = self::formatValue($row[$columnName], $columnName);
            // }
            $row["ROWNUM"] = $i;

            $i++;
        }
    }
    
    public function getColumnNames()
    {
        return $this->columnNames;
    }
    
    public function setColumnNames($columnNames)
    {
        $this->columnNames = $columnNames;
    }
}
