/* Tabela SERVCLIE */
/* Descrio: A trigger insere registros na tabela LOGOPERAESPE a partir de alteraes na tabela SERVCLIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SERVCLIE
             utilizando a tabela Geral de Logs de Operaes especficas*/
/* Criao:
/* 23/05/2007 - Fabrcio Marcelo Silva */


CREATE OR REPLACE TRIGGER SDXLOG_CLIESERV
AFTER INSERT OR DELETE ON SERVCLIE FOR EACH ROW
DECLARE
   V_IDUTLOGCLIESERV  VARCHAR2(1);
   V_IDTIPOOPER       VARCHAR2(1);  /* V_IDTIPOOPER - 'I' - Incluso, 'E' - Excluso */
   V_CLIENT_INFO      VARCHAR2(64);
   V_CDOPERADOR       VARCHAR2(12);
   V_CDFILIAL         VARCHAR2(4);
   V_DESC             VARCHAR2(100);
BEGIN
   BEGIN
      SELECT IDUTLOGCLIESERV
      INTO V_IDUTLOGCLIESERV
      FROM PARAMGERAL
      WHERE CDPARGERAL = '0001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTLOGCLIESERV := 'N';
   END;

   IF V_IDUTLOGCLIESERV = 'S' THEN

      V_IDTIPOOPER  := '';
      V_CLIENT_INFO := '';
      V_CDOPERADOR  := '';
      V_CDFILIAL    := '';
      V_DESC        := '';

      /* Retorna o codigo e o nome do operador */
      DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
      V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,1,12);

      IF INSERTING THEN

         V_DESC := 'Filial:'  || ' ' || :NEW.CDFILIAL  || ' ' ||
                   'Cliente:' || ' ' || :NEW.CDCLIENTE || ' ' ||
                   'Servico:' || ' ' || :NEW.CDSERVFILI;

         V_IDTIPOOPER := 'I';

         V_CDFILIAL   := :NEW.CDFILIAL;
      ELSE
         IF DELETING THEN

            V_DESC := 'Filial:'  || ' ' || :OLD.CDFILIAL  || ' ' ||
                      'Cliente:' || ' ' || :OLD.CDCLIENTE || ' ' ||
                      'Servico:' || ' ' || :OLD.CDSERVFILI;

            V_IDTIPOOPER := 'E';

            V_CDFILIAL   := :OLD.CDFILIAL;
         END IF;
      END IF;

      IF NOT (V_DESC IS NULL) THEN

         V_DESC := SUBSTR(V_DESC, 1, 100);

         INSERT INTO LOGOPERAESPE (NMOPERAESPE,     DTOPERAESPE, IDOPERAESPE,
                                   CDOPERRESPOPERA, DSOPERAESPE, CDFILIRESPOPERA)
                     VALUES ('Cliente Servico', SYSDATE, V_IDTIPOOPER,
                             V_CDOPERADOR, V_DESC, V_CDFILIAL);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SDXLOG_CLIESERV','5.05.021'); END;
/

